<?php
/**
 * Clase Base DP para BaseCrEventoTipoDP
 *
 * @package    
 * @subpackage BaseCrEventoTipoDP
 * @author     Willy
 * @version    SVN:: BaseCrEventoTipoDP.class.php,v 1.1 2023-02-23 11:14:33 william.taype Exp $
 */
abstract class BaseCrEventoTipoDP extends CrEventoTipoBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrEventoTipoBN )
    {
      $o_CrEventoTipoBN = $bSetDefault;
      if($o_CrEventoTipoBN->getIdEventoTipo()) : $this->setIdEventoTipo($o_CrEventoTipoBN->getIdEventoTipo()); endif;
      if($o_CrEventoTipoBN->getDecripcion()) : $this->setDecripcion($o_CrEventoTipoBN->getDecripcion()); endif;
      if($o_CrEventoTipoBN->getEstado()) : $this->setEstado($o_CrEventoTipoBN->getEstado()); endif;
      if($o_CrEventoTipoBN->getFechaCreacion()) : $this->setFechaCreacion($o_CrEventoTipoBN->getFechaCreacion()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdEventoTipo),(MAX(IdEventoTipo)+1), 1) AS Maximo FROM cr_evento_tipo;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdEventoTipo($row[0]);

      if($this->getIdEventoTipo()){
        $a_Fields = array();

        if($this->getIdEventoTipo()) : $a_Fields['IdEventoTipo'] = ($this->getIdEventoTipo()); endif;
        if($this->getDecripcion()) : $a_Fields['Descripcion'] = ($this->getDecripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_evento_tipo (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdEventoTipo())
      {
        $a_Fields = array();

        if($this->getIdEventoTipo()) : $a_Fields['IdEventoTipo'] = ($this->getIdEventoTipo()); endif;
        if($this->getDecripcion()) : $a_Fields['Descripcion'] = ($this->getDecripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_evento_tipo SET ".$sStringField." WHERE 1 AND IdEventoTipo='".$this->getIdEventoTipo()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdEventoTipo())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_evento_tipo WHERE 1 AND IdEventoTipo='".$this->getIdEventoTipo()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdEventoTipo)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEventoTipo, Descripcion, Estado, FechaCreacion FROM cr_evento_tipo WHERE 1 AND IdEventoTipo='".$vIdEventoTipo."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrEventoTipoDP = new CrEventoTipoDP();
    $o_CrEventoTipoDP->setIdEventoTipo($o_propel->IdEventoTipo);
    $o_CrEventoTipoDP->setDecripcion($o_propel->Descripcion);
    $o_CrEventoTipoDP->setEstado($o_propel->Estado);
    $o_CrEventoTipoDP->setFechaCreacion($o_propel->FechaCreacion);
    return $o_CrEventoTipoDP;
  }
}